package im.zego.minigameenginedemo;

import android.content.res.Resources;
import android.util.SparseArray;

import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Random;

import im.zego.minigameengine.ZegoGameEngineError;
import im.zego.minigameengine.ZegoGameLanguage;
import im.zego.minigameenginedemo.model.LiveModel;
import im.zego.minigameenginedemo.utils.CommonUtils;

public class ZegoConstants {
    public static final Gson gson = new Gson();
    public static final String LIVE_ROOM_PREFIX = "mini_game_";  // 房间的ID的前缀
    public static final long BUSINESS_POINT_RESET = 100000;  // 业务积分初始值
    public static final long EXCHANGE_POINT_NUMBER = 10000;  // 每次兑换的积分

    private static final SparseArray<String> errorMap = new SparseArray<>();
    // 直播间/语聊房信息
    public static ArrayList<LiveModel> liveModelList = new ArrayList<LiveModel>(Arrays.asList(new LiveModel(LiveModel.RoomType.CHAT_ROOM, "1"),
            new LiveModel(LiveModel.RoomType.CHAT_ROOM, "2"), new LiveModel(LiveModel.RoomType.CHAT_ROOM, "3"), new LiveModel(LiveModel.RoomType.CHAT_ROOM, "4"),
            new LiveModel(LiveModel.RoomType.CHAT_ROOM, "5"), new LiveModel(LiveModel.RoomType.CHAT_ROOM, "6"), new LiveModel(LiveModel.RoomType.LIVE_ROOM, "1"),
            new LiveModel(LiveModel.RoomType.LIVE_ROOM,"2"), new LiveModel(LiveModel.RoomType.LIVE_ROOM,"3"), new LiveModel(LiveModel.RoomType.LIVE_ROOM,"4"),
            new LiveModel(LiveModel.RoomType.LIVE_ROOM,"5"), new LiveModel(LiveModel.RoomType.LIVE_ROOM,"6"), new LiveModel(LiveModel.RoomType.GAME_ROOM, "1"),
            new LiveModel(LiveModel.RoomType.GAME_ROOM,"2"), new LiveModel(LiveModel.RoomType.GAME_ROOM,"3"), new LiveModel(LiveModel.RoomType.GAME_ROOM,"4"),
            new LiveModel(LiveModel.RoomType.GAME_ROOM,"5"), new LiveModel(LiveModel.RoomType.GAME_ROOM,"6")
    ));

    public static String[] randomNames = {"张三", "李四", "王五", "武则天", "秦始皇", "刘邦", "项羽", "女娲", "王昭君", "西施",
            "貂蝉", "杨玉环", "赵飞燕", "上官婉儿", "孙悟空", "唐僧", "猪八戒", "牛魔王", "盘古", "太上老君", "周瑜", "吴刚"
    };
    public static String[] randomAvatar = {
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F73646baf37d88ab727e45be5ab2a2158%2F16%2F73646baf37d88ab727e45be5ab2a2158%2Fthumbnails%2F1.png?vf6o0nq2nqa2egs9",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2Fb7d2b72179deb6f134ca3006709e865c%2F16%2Fb7d2b72179deb6f134ca3006709e865c%2Fthumbnails%2F1.png?8m79mtgw0h2rqqhx",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F61795d64787b32be071a61815cf305f0%2F16%2F61795d64787b32be071a61815cf305f0%2Fthumbnails%2F1.png?x71e2k5hkdjy6d9d",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2Fc123c70be5a933d24119ab9a7023d941%2F16%2Fc123c70be5a933d24119ab9a7023d941%2Fthumbnails%2F1.png?fnvzwzqdfa5umu0q",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2Fbdf1f499db619c8d007993f2f80b3a08%2F16%2Fbdf1f499db619c8d007993f2f80b3a08%2Fthumbnails%2F1.png?ugdhfdidkepug1uw",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F99fe2e224d26ad4f747f3f8c973b8a37%2F16%2F99fe2e224d26ad4f747f3f8c973b8a37%2Fthumbnails%2F1.png?6tub8wo058btyxlt",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F4ed11a20532ba7b2115e9288ed72b5a5%2F16%2F4ed11a20532ba7b2115e9288ed72b5a5%2Fthumbnails%2F1.png?zfbbm6uny2w7mezf",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F8d6abe9c6f744bfe26e12f459e4d454a%2F16%2F8d6abe9c6f744bfe26e12f459e4d454a%2Fthumbnails%2F1.png?55krvuez9ogs5lgf",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F299f3c1b5d502e3fc1acb70222385c9b%2F16%2F299f3c1b5d502e3fc1acb70222385c9b%2Fthumbnails%2F1.png?opvop22azg75d6e6",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F29ff384c19afd85418a665ad30ed599f%2F16%2F29ff384c19afd85418a665ad30ed599f%2Fthumbnails%2F1.png?g8gny92brmg421h4",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F0fefb0b0dddbaf5b0d8801e17bd27085%2F16%2F0fefb0b0dddbaf5b0d8801e17bd27085%2Fthumbnails%2F1.png?n0uj3to4diztaz2c",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F45ed2bf73239d6bc9e90bfc27d3d059e%2F16%2F45ed2bf73239d6bc9e90bfc27d3d059e%2Fthumbnails%2F1.png?ybqr3lrmuw45c7v7",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F732f10bfe988cca9c32779b2d6cd50ec%2F16%2F732f10bfe988cca9c32779b2d6cd50ec%2Fthumbnails%2F1.png?wbyfrzrsuxjnjdpp",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2Ffbb3fd12a3c8e5d03b6608c231c6899e%2F16%2Ffbb3fd12a3c8e5d03b6608c231c6899e%2Fthumbnails%2F1.png?eu7bqwr8lsydfk1v",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2F7c59ce2bc7fe93083a1d68a34ff37c22%2F16%2F7c59ce2bc7fe93083a1d68a34ff37c22%2Fthumbnails%2F1.png?i72ntxnqcd7npmem",
            "https://docservice-storage-alpha.zego.im/00c483552faefc8df47184643f9defee%2Fb63236dcfca4ea5efeb48fbaf2769147%2F16%2Fb63236dcfca4ea5efeb48fbaf2769147%2Fthumbnails%2F1.png?u980x6c9mhcj87gj"
    };

    public static Random rand = new Random();

    public static final String getRandomName() {
        int nameRandomIndex = rand.nextInt(randomNames.length);
        return randomNames[nameRandomIndex];
    }

    public static final String getRandomAvatar() {
        int avatarRandomIndex = rand.nextInt(randomAvatar.length);
        return randomAvatar[avatarRandomIndex];
    }

    public static final String getRoomID(int position) {
        LiveModel liveModel = liveModelList.get(position);
        String type = liveModel.roomType == LiveModel.RoomType.LIVE_ROOM ? "live" :
                liveModel.roomType == LiveModel.RoomType.CHAT_ROOM ? "chat" : "gameRoom";

        String roomID = LIVE_ROOM_PREFIX + type + liveModel.liveName;
        return roomID;
    }

    private static Resources res;
    static {
        res = CommonUtils.getApplication().getResources();
        errorMap.put(ZegoGameEngineError.ERROR_NETWORK, res.getString(R.string.error_network));
        errorMap.put(ZegoGameEngineError.ERROR_INVALID_USER_INFO, res.getString(R.string.error_invalid_user_info));
        errorMap.put(ZegoGameEngineError.ERROR_INVALID_PARAMS, res.getString(R.string.error_invalid_parameters));
        errorMap.put(ZegoGameEngineError.ERROR_INVALID_TOKEN, res.getString(R.string.error_invalid_token));
        errorMap.put(ZegoGameEngineError.ERROR_INVALID_ROOM_ID, res.getString(R.string.error_invalid_room_id));
        errorMap.put(ZegoGameEngineError.ERROR_INVALID_GAME_ID, res.getString(R.string.error_invalid_game_id));
        errorMap.put(ZegoGameEngineError.ERROR_TIME_OUT, res.getString(R.string.error_timeout));
        errorMap.put(ZegoGameEngineError.ERROR_ALREADY_INIT, res.getString(R.string.error_already_init));
        errorMap.put(ZegoGameEngineError.ERROR_NOT_INIT, res.getString(R.string.error_not_init));
        errorMap.put(ZegoGameEngineError.ERROR_NOT_SET_GAME_CONTAINER, res.getString(R.string.error_not_set_container));
        errorMap.put(ZegoGameEngineError.ERROR_GAME_INFO_IS_NULL, res.getString(R.string.error_game_info_is_null));
        errorMap.put(ZegoGameEngineError.ERROR_GAME_IS_NOT_RUNNING, res.getString(R.string.error_is_not_running_game));
        errorMap.put(ZegoGameEngineError.ERROR_GAME_NOT_SUPPORT_THIS_MODE, res.getString(R.string.error_this_game_not_support_this_mode));
        errorMap.put(ZegoGameEngineError.ERROR_REGION_LIMIT, "Restricted area.");
        errorMap.put(ZegoGameEngineError.ERROR_GAME_ALREADY_LOADED, "Game already loaded.");
        errorMap.put(ZegoGameEngineError.ERROR_CAN_NOT_DOWNLOAD_WHEN_GAME_IS_PLAYING, "Can't preload game when playing the game.");
        errorMap.put(ZegoGameEngineError.ERROR_DOWNLOAD_GAME_FAIL, "Download game failed.");
        errorMap.put(ZegoGameEngineError.ERROR_ZEGO_CONNECTION_INIT_FAIL, "Zego connection init failed.");
        errorMap.put(ZegoGameEngineError.ERROR_UNZIP_FILE_FAIL, "Unzip file failed.");
        errorMap.put(ZegoGameEngineError.ERROR_ALREADY_IN_PRELOADING, "Already in preloading.");
        errorMap.put(ZegoGameEngineError.ERROR_PRELOAD_CANCELED, "Preload game canceled");
        errorMap.put(7208001, "腾讯云没有空闲的并发");
        errorMap.put(7200401, "Invalid token or expired token.");
    }

    public static final String getErrorMsg(int errorCode) {
        String errMsg = errorMap.get(errorCode);
        if (errMsg == null) {
            return "error Info：" + errorCode;
        } else {
            return errMsg;
        }
    }

    public static class GameLanguage {
        public ZegoGameLanguage gameLanguage;
        public String text;

        public GameLanguage(ZegoGameLanguage gameLanguage, String text) {
            this.gameLanguage = gameLanguage;
            this.text = text;
        }

        @Override
        public String toString() {
            return text;
        }
    }

    // 支持的语言
    public static final GameLanguage[] gameLanguages = new GameLanguage[]{
            new GameLanguage(ZegoGameLanguage.zh_CN, res.getString(R.string.language_zh)),
            new GameLanguage(ZegoGameLanguage.zh_TW, res.getString(R.string.language_tzh)),
            new GameLanguage(ZegoGameLanguage.en, res.getString(R.string.language_en)),
            new GameLanguage(ZegoGameLanguage.ja, res.getString(R.string.language_ja)),
            new GameLanguage(ZegoGameLanguage.ko, res.getString(R.string.language_ko)),
            new GameLanguage(ZegoGameLanguage.ru, res.getString(R.string.language_ru)),
            new GameLanguage(ZegoGameLanguage.th, res.getString(R.string.language_th)),
            new GameLanguage(ZegoGameLanguage.ar, res.getString(R.string.language_ar)),
            new GameLanguage(ZegoGameLanguage.fil, res.getString(R.string.language_fil)),
            new GameLanguage(ZegoGameLanguage.es, res.getString(R.string.language_sp)),
            new GameLanguage(ZegoGameLanguage.pt, res.getString(R.string.language_pt)),
            new GameLanguage(ZegoGameLanguage.ms, res.getString(R.string.language_ms))
    };

}
