package im.zego.minigameenginedemo.ui.main;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;

import im.zego.minigameengine.ZegoGameInfo;
import im.zego.minigameenginedemo.R;

public class ChoseGameListAdapter extends GameListAdapterBase {
    protected OnRecyclerViewItemClickListener itemClickListener;
    protected RecyclerView recyclerView;

    @Override
    public void onAttachedToRecyclerView(@NonNull RecyclerView recyclerView) {
        super.onAttachedToRecyclerView(recyclerView);
        this.recyclerView = recyclerView;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.chose_game_item_layout, parent, false);
        GameViewHolder gameViewHolder = new GameViewHolder(view);
        return gameViewHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        GameViewHolder gameViewHolder = (GameViewHolder)holder;
        ZegoGameInfo gameInfo = dataList.get(position);
        gameViewHolder.itemTv.setText(gameInfo.gameName);
        Glide.with(gameViewHolder.itemImage).load(gameInfo.thumbnail).into(gameViewHolder.itemImage);
        final int thisPosition = position;
        gameViewHolder.itemView.setOnClickListener(v -> {
            if (isSelectable) {
                int oldSelectID = selectID;
                selectID = thisPosition;
                notifyItemChanged(oldSelectID);
                notifyItemChanged(selectID);
            }
            if (itemClickListener != null) {
                itemClickListener.onItemClick(recyclerView, v, position);
            }
        });

        gameViewHolder.itemView.setOnLongClickListener(v -> {
            if (itemClickListener != null) {
                itemClickListener.onItemClick(recyclerView, v, position);
            }
            return false;
        });

        if (isSelectable && selectID == position) {
            gameViewHolder.itemView.setSelected(true);
        } else {
            gameViewHolder.itemView.setSelected(false);
        }
    }

    public void setItemClickListener(OnRecyclerViewItemClickListener itemClickListener) {
        this.itemClickListener = itemClickListener;
    }
}
