package im.zego.minigameenginedemo.ui.main;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.minigameengine.ZegoGameInfo;
import im.zego.minigameengine.ZegoMiniGameEngine;
import im.zego.minigameenginedemo.R;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link CloudGameListFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class CloudGameListFragment extends Fragment {

    private MiniGameMainViewModel viewModel;
    private RecyclerView gameListRecyclerView;
    private MallGameListAdapter gameListAdapter = new MallGameListAdapter();

    public CloudGameListFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @return A new instance of fragment GameListFragment.
     */
    public static CloudGameListFragment newInstance() {
        return new CloudGameListFragment();
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        viewModel = new ViewModelProvider(requireActivity()).get(MiniGameMainViewModel.class);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_game_list, container, false);
        gameListRecyclerView = view.findViewById(R.id.recyclerview_game_list);
        GridLayoutManager layoutManager = new GridLayoutManager(requireContext(), 3); // 每行2个
        gameListRecyclerView.setLayoutManager(layoutManager);
        gameListRecyclerView.setAdapter(gameListAdapter);
        gameListAdapter.setSelectable(true);
        gameListAdapter.setItemClickListener(new OnRecyclerViewItemClickListener() {
            @Override
            public void onItemClick(RecyclerView recyclerView, View view, int position) {
                viewModel.isHost = false;
                viewModel.roomID = "";
                ZegoGameInfo gameInfo = gameListAdapter.getDataList().get(position);
                Fragment cloudGameFragment = CloudGameFragment.newInstance(gameInfo.gameID);
                requireActivity().getSupportFragmentManager().beginTransaction()
                        .add(R.id.container, cloudGameFragment, "cloudGameFragment")
                        .addToBackStack(null)
                        .commit();
            }

            @Override
            public void onItemLongClick(RecyclerView recyclerView, View view, int position) {
                // ignore
            }
        });
        viewModel.cloudGameList.observe(requireActivity(), gameInfoList -> {
            gameListAdapter.setDataList(gameInfoList);
        });
        return view;
    }

    @Override
    public String toString() {
        return getString(R.string.game_mall);
    }
}