package im.zego.minigameenginedemo.ui.main;

import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.util.List;

import im.zego.minigameengine.ZegoGameInfo;
import im.zego.minigameenginedemo.R;

public abstract class GameListAdapterBase extends RecyclerView.Adapter<RecyclerView.ViewHolder> {
    protected List<ZegoGameInfo> dataList;
    protected boolean isSelectable = false;
    protected int selectID = -1;

    public void setSelectable(boolean isSelectable) {
        this.isSelectable = isSelectable;
    }

    public int getSelectPosition() {
        return selectID;
    }

    @Override
    public int getItemCount() {
        return dataList != null ? dataList.size() : 0;
    }

    public static class GameViewHolder extends RecyclerView.ViewHolder {
        public TextView itemTv;
        public ImageView itemImage;
        public GameViewHolder(@NonNull View itemView) {
            super(itemView);
            itemTv = itemView.findViewById(R.id.item_tv);
            itemImage = itemView.findViewById(R.id.game_image);
        }
    }

    public void setDataList(List<ZegoGameInfo> dataList) {
        this.dataList = dataList;
        notifyDataSetChanged();
    }

    public List<ZegoGameInfo> getDataList() {
        return dataList;
    }
}
