package im.zego.minigameenginedemo.ui.main;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;

import im.zego.minigameengine.ZegoGameInfo;
import im.zego.minigameenginedemo.R;

public class MallGameListAdapter extends ChoseGameListAdapter {

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.chose_game_mall_item_layout, parent, false);
        GameViewHolder gameViewHolder = new GameViewHolder(view);
        return gameViewHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        GameViewHolder gameViewHolder = (GameViewHolder)holder;
        ZegoGameInfo gameInfo = dataList.get(position);
        gameViewHolder.itemTv.setText(gameInfo.gameName);
        Glide.with(gameViewHolder.itemImage).load(gameInfo.thumbnail).into(gameViewHolder.itemImage);
        final int thisPosition = position;
        gameViewHolder.itemView.setOnClickListener(v -> {
            if (itemClickListener != null) {
                itemClickListener.onItemClick(recyclerView, v, thisPosition);
            }
        });

        gameViewHolder.itemView.setOnLongClickListener(v -> {
            if (itemClickListener != null) {
                itemClickListener.onItemClick(recyclerView, v, position);
            }
            return false;
        });
    }
}
