package im.zego.minigameenginedemo.ui.main;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import im.zego.minigameenginedemo.R;
import im.zego.minigameenginedemo.RTCEngineManager;

public class MemberListAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder>{
    private List<RTCEngineManager.RTCUser> dataList = new ArrayList<>();
    private String hostID;

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.member_item_layout, parent, false);
        MemberViewHolder memberViewHolder = new MemberViewHolder(view);
        return memberViewHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        MemberViewHolder memberViewHolder = (MemberViewHolder)holder;
        RTCEngineManager.RTCUser user = dataList.get(position);
        memberViewHolder.memberNameTv.setText(user.userName);
        if (user.userID.equals(hostID)) {
            memberViewHolder.hostMarkTv.setVisibility(View.VISIBLE);
        } else {
            memberViewHolder.hostMarkTv.setVisibility(View.GONE);
        }
    }

    @Override
    public int getItemCount() {
        return dataList == null ? 0 : dataList.size();
    }

    public void setHostID(String hostID) {
        this.hostID = hostID;
        for (RTCEngineManager.RTCUser rtcUser: dataList) {
            if (rtcUser.userID.equals(hostID)) {
                rtcUser.type = 0;
                break;
            }
        }
        Collections.sort(dataList, (o1, o2) -> o1.type - o2.type);
        notifyDataSetChanged();
    }

    public static class MemberViewHolder extends RecyclerView.ViewHolder {
        public TextView memberNameTv;
        public TextView hostMarkTv;
        public MemberViewHolder(@NonNull View itemView) {
            super(itemView);
            hostMarkTv = itemView.findViewById(R.id.host_mark);
            memberNameTv = itemView.findViewById(R.id.member_name);
        }
    }

    public void setDataList(List<RTCEngineManager.RTCUser> dataList) {
        Collections.sort(dataList, (o1, o2) -> o1.type - o2.type);

        this.dataList = dataList;
        notifyDataSetChanged();
    }
}
