package im.zego.minigameenginedemo.ui.main;

import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import im.zego.minigameenginedemo.R;

public class SelectItemView extends RelativeLayout {
    private TextView nameTv;
    private ImageView imageView;
    private View bottomDivider;

    public SelectItemView(Context context) {
        this(context, null);
    }

    public SelectItemView(Context context, AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public SelectItemView(Context context, AttributeSet attrs, int defStyleAttr) {
        this(context, attrs, defStyleAttr, 0);
    }

    public SelectItemView(Context context, AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
        init();
    }

    private void init() {
        View view = LayoutInflater.from(getContext()).inflate(R.layout.select_item_layout, this, true);
        nameTv = view.findViewById(R.id.name);
        imageView = view.findViewById(R.id.image_view);
        bottomDivider = view.findViewById(R.id.bottom_divider);
    }

    public void setText(String text) {
        nameTv.setText(text);
    }

    public void setSelected(boolean isSelected) {
        imageView.setImageResource(isSelected ? R.drawable.icon_tick_select : 0);
    }

    public void setBottomItem(boolean isBottom) {
        bottomDivider.setVisibility(isBottom ? View.GONE : View.VISIBLE);
    }
}
