package im.zego.minigameenginedemo.view;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.util.AttributeSet;
import android.util.TypedValue;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.constraintlayout.widget.ConstraintLayout;

import im.zego.minigameenginedemo.R;

public class ZegoCustomButton extends ConstraintLayout {
    private ViewGroup buttonLayout;
    private ImageView imageView;
    private TextView textView;
    public ZegoCustomButton(@NonNull Context context) {
        this(context, null);
    }

    public ZegoCustomButton(@NonNull Context context, @Nullable AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public ZegoCustomButton(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        this(context, attrs, defStyleAttr, 0);
    }

    public ZegoCustomButton(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
        View rootView = LayoutInflater.from(context).inflate(R.layout.zego_custom_button_layout, this);
        buttonLayout = rootView.findViewById(R.id.sub_button_layout);
        textView = rootView.findViewById(R.id.item_text_view);
        imageView = rootView.findViewById(R.id.item_image_view);
    }

    public void setText(String text) {
        textView.setText(text);
    }

    public void setTextSize(float sizeInDP) {
        textView.setTextSize(TypedValue.COMPLEX_UNIT_DIP, sizeInDP);
    }

    public void setTextColor(int color) {
        textView.setTextColor(color);
    }

    public void showTextView(boolean isShow) {
        textView.setVisibility(isShow ? View.VISIBLE : View.GONE);
    }

    public void setImageResource(int resource) {
        imageView.setImageResource(resource);
    }

    public void showImageView(boolean isShow) {
        imageView.setVisibility(isShow ? View.VISIBLE : View.GONE);
    }

    @Override
    public void setBackground(Drawable background) {
        buttonLayout.setBackground(background);
    }
}
